/* ElistConv 1.0 by Johan Billing

   This script converts an echolist created by the program Elist to a
   format that CrashMail understands.

   Syntax: rx ElistConv.rexx <Elist file> <output file>

*/

parse arg echoname" "outname

IF ~SHOW(Libraries,'rexxsupport.library') THEN
    IF ~ADDLIB("rexxsupport.library",0,-30,0) THEN EXIT

call open('echofile',echoname,'R')
call open('outfile',outname,'W')

kg=true

do while kg=true
 inline=readln('echofile')
 if left(inline,1)="-" then kg=false
end

kg=true

do while kg=true
 inline=readln('echofile')

 if left(inline,1)="-" then do
  kg=false
 end
 else do
  parse var inline tagname mailweek moderator language access rules desc
  tagname=strip(tagname)
  desc=strip(desc)
  tagname=overlay(tagname,"",1,max(30,length(tagname)))
  call writeln('outfile',tagname desc)
 end

 if eof('echofile') then kg=false
end


call close('echofile')
call close('outfile')

